######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

database standard

globals
    define

        ##############################################################
        # Codegen area
        ##############################################################
        # Global variables in this section will be overwritten
        # during a re-generation of source code.
        # Place any custom global variables above this section.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        m_ropend record like stropend.*,  # record like open items
        m_rcntrc record like strcntrc.*,  # record like /a/r control record
        oa_amt  like strcustr.on_acct_amt,
        oa_acct like strcustr.ar_acct_dflt,
        oa_department like strcustr.ar_department_dflt,
        m_rcashe record like strcashe.*,  # Record like the header table
        p_rcashe record   # Record like the header screen
            rcpt_date like strcashe.rcpt_date,
            cust_code like strcashe.cust_code,
            bus_name like strcustr.bus_name,
            check_no like strcashe.check_no,
            doc_desc like strcashe.doc_desc,
            rcpt_amt like strcashe.cash_amt,
            on_acct_amt like strcustr.on_acct_amt,
            auto_pay char(8),
            cash_acct like strcashe.cash_acct,
            cash_department like strcashe.cash_department,
            disc_tot like strcashe.cash_amt,
            paid_tot like strcashe.cash_amt,
            bal_remaining like strcashe.cash_amt
        end record,
        q_rcashe record   # Parallel header record
            row_id integer  # SQL rowid
        end record,
        m_rcashd record like strcashd.*,  # Record like the detail table
        p_rcashd array[100] of record   # Record like the detail screen
            pay_method char(1),
            inv_no like stropend.inv_no,
            due_date like stropend.due_date,
            disc_date like stropend.disc_date,
            disc_bal like stropend.disc_bal,
            balance like stropend.balance,
            disc_amt like strcashd.disc_amt,
            paid like strcashd.dist_amt
        end record,
        q_rcashd array[100] of record   # Parallel detail record
            row_id integer,  # SQL rowid
            inv_doc_no like strcashd.inv_doc_no,
            dist_acct like strcashd.dist_acct,
            dist_department like strcashd.dist_department
        end record,
        scr1_max smallint,   # Number of elements in screen array 1
        rec1_max smallint,   # Number of elements in record array 1
        rec1_cnt smallint,   # Number of active elements in array 1

        ###############################################################
        # Library communication area 3.51.00
        ###############################################################
        # Global variables in this section should not be changed.
        # They are used to communicate to the screen library functions,
        # and must be of the same type as defined in the library.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        progid       char(17),   # Program identification
        scr_id       char(7),    # Current screen id
        menu_item    char(10),   # Current menu item running
        scr_funct    char(20),   # Current screen function being run
        sql_filter   char(512),  # Filter portion of SQL statement
        sql_order    char(100),  # Order portion of SQL statement
        input_num    smallint,   # Current input section within screen
        p_cur        smallint,   # Current input array element
        s_cur        smallint,   # Current screen array element
        scr_fld      char(40),   # Current screen field
        nxt_fld      char(40),   # Programmatic next screen field
        prev_data    char(80),   # Data before field entry
        this_data    char(80),   # Data after field entry
        data_changed smallint,   # Has the field data changed?
        hotkey       smallint,   # The hot key that has been pressed
        scratch      char(2047)  # Scratchpad for scribbling on and
                                 # communicating between functions
        # End library communication area
        ###############################################################

end globals
