########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_arcshe.4gs/screen.trg  1.7  Delta: 2/14/91
########################################################################
defaults
    libraries
        ../../all.4gm/lib.a;
    do_not_generate
        llh_lookup
        lld_read
        lld_add;
    define
        m_ropend record like stropend.*,  # record like open items
        m_rcntrc record like strcntrc.*,  # record like /a/r control record
        oa_amt  like strcustr.on_acct_amt,
        oa_acct like strcustr.ar_acct_dflt,
        oa_department like strcustr.ar_department_dflt,;
    after_init
        # don't allow insert on detail lines because
        # the users shouldn't be able to add lines
        options insert key f36
        call rcontrol() returning m_rcntrc.*;
    switchbox_items
        arinvcz arinvcz() # ar invoice detail
        ariactz ariactz() # ar invoice detail
        aronacz aronacz() 
        cractvz cractvz() 
        aractvz aractvz() 
        arshipz arshipz();
input 1
    after_field cash_department
        if p_rcashe.cash_department is null
          then let p_rcashe.cash_department = "000" end if;
    on_screen_record_prep
        let p_rcashe.rcpt_amt = m_rcashe.cash_amt
        if m_rcashe.cash_deb_cred = "CR"
        then
            let p_rcashe.rcpt_amt = m_rcashe.cash_amt * -1
        end if
        let oa_amt = m_rcashe.oa_amt

        if m_rcashe.oa_deb_cred = "DB"
        then
            let oa_amt = m_rcashe.oa_amt * -1
        end if
        let p_rcashe.cash_acct = m_rcashe.cash_acct
        let p_rcashe.cash_department = m_rcashe.cash_department
        let oa_acct = m_rcashe.oa_acct
        let oa_department = m_rcashe.oa_department
        # if other cash receipts with same customer code
        # then recalculate the p_rcashe.on_acct_amt variable
        if dup_cust() 
        then
            call calc_on_acct()
        end if
        let p_rcashe.paid_tot = p_rcashe.rcpt_amt - oa_amt
        let p_rcashe.bal_remaining =
              (p_rcashe.rcpt_amt - p_rcashe.paid_tot - p_rcashe.on_acct_amt)
        # general defaults
        if p_rcashe.rcpt_date is null
          then let p_rcashe.rcpt_date = today end if
        if p_rcashe.rcpt_amt is null
          then let p_rcashe.rcpt_amt = 0 end if
        if p_rcashe.on_acct_amt is null
          then let p_rcashe.on_acct_amt = 0 end if
        if oa_amt is null 
          then let oa_amt = 0 end if
        if p_rcashe.cash_acct is null
          then let p_rcashe.cash_acct = m_rcntrc.cr_cash_acct_no end if
        if p_rcashe.cash_department is null
          then let p_rcashe.cash_department = "000" end if
        if p_rcashe.rcpt_amt is null
          then let p_rcashe.rcpt_amt = 0 end if
        if p_rcashe.disc_tot is null
          then let p_rcashe.disc_tot = 0 end if
        if p_rcashe.paid_tot is null
          then let p_rcashe.paid_tot = 0 end if
        if p_rcashe.bal_remaining is null
          then let p_rcashe.bal_remaining = 0 end if
        let p_rcashe.auto_pay = " ";
    on_disk_record_prep
        let oa_amt = p_rcashe.rcpt_amt - p_rcashe.paid_tot +
                     p_rcashe.disc_tot
        let m_rcashe.cash_amt = p_rcashe.rcpt_amt
        let m_rcashe.cash_deb_cred = "DB"
        if p_rcashe.rcpt_amt < 0
        then
            let m_rcashe.cash_amt = p_rcashe.rcpt_amt * -1
            let m_rcashe.cash_deb_cred = "CR"
        end if
        let m_rcashe.oa_amt = oa_amt
        let m_rcashe.oa_deb_cred = "CR"
        if oa_amt < 0
        then
            let m_rcashe.oa_amt = oa_amt * -1
            let m_rcashe.oa_deb_cred = "DB"
        end if
        let m_rcashe.oa_acct = oa_acct
        let m_rcashe.oa_department = oa_department
        let m_rcashe.ok_to_post = "N";
    after_field rcpt_date
        if p_rcashe.rcpt_date is null
          then let p_rcashe.rcpt_date = today end if;
    after_change_in rcpt_date
        # make sure g/l is installed
        if table_exist("stgcntrc") 
        then
            # check to see if document date is within
            #   current period
            if per_warn(p_rcashe.rcpt_date) = true
            then
               # Warning:  Date Outside Current Period.
               call fg_err(13)
            end if
        end if;
    after_change_in cust_code
        if not new_cust()
        then
            let p_rcashe.cust_code = null
            if int_flag != 0
            then
                let nxt_fld = "exit input"
                return
            end if
            let nxt_fld = "cust_code"
            return
        end if
        let p_rcashe.cash_acct = m_rcntrc.cr_cash_acct_no
        let p_rcashe.cash_department = "000";
    after_field rcpt_amt
        if p_rcashe.rcpt_amt is null
          then let p_rcashe.rcpt_amt = 0 end if;
    after_change_in rcpt_amt
        let p_rcashe.rcpt_amt = round( "a", p_rcashe.rcpt_amt )
        let p_rcashe.bal_remaining = p_rcashe.bal_remaining -
            prev_data + p_rcashe.rcpt_amt;
    after_change_in auto_pay
        if p_rcashe.auto_pay = "Y"
        then 
            call automatic_pay() 
            let p_rcashe.auto_pay = null
        end if;
    after_input
        if mustfill(p_rcashe.cust_code,"Customer Code")
          then let nxt_fld = "cust_code" return end if
        if mustfill(p_rcashe.rcpt_date,"Receipt Date")
          then let nxt_fld = "rcpt_date" return end if
        if mustfill(p_rcashe.cash_acct,"Cash Account Number")
          then let nxt_fld = "cash_acct" return end if
        if mustfill(p_rcashe.cash_department,"Cash Department Code")
          then let nxt_fld = "cash_department" return end if
        if tab_pressed = false
          then call cust_unlock() end if;
    on_event cancel
        call cust_unlock()
        if no_cancel()
        then
          let int_flag = false
          let nxt_fld = null
        else
          let int_flag = true
          let nxt_fld = "exit input"
        end if;
    at_eof
######################################################################
function llh_lookup(tbl_name,mustfind)
# returning false if notfound
######################################################################
# This is the lookup function.  It is passed a table to lookup, and
# based on that, it looks up the key and fills any variables for
# that table.  The lookup function will produce the error if it is
# called with mustfind=true, and a notfound situation exists.
#
    define
        tbl_name char(18),  # Lookup table name
        stat integer,       # Value of sqlca.sqlcode after lookup
        mustfind smallint   # (boolean) produce an error if notfound?

    # Prepare cursors upon first call to this function
    if lookup_prep is null
    then
        let lookup_prep = "Y"
        let scratch = "select bus_name, on_acct_amt ",
          "from strcustr where ",
          " strcustr.cust_code = ?"
        prepare str_cust_look from scratch
        declare cur_cust_look cursor for str_cust_look
        let scratch = "select rowid ",
          "from stxchrtr where stxchrtr.acct_no = ?"
        prepare str_acct_look from scratch
        declare cur_acct_look cursor for str_acct_look
        let scratch = "select rowid ",
          "from stxinfor where ",
          " stxinfor.src_type = \"D\" and stxinfor.src_key = ?"
        prepare str_dept_look from scratch
        declare cur_dept_look cursor for str_dept_look
    end if

    # Perform the lookup
    case
      when tbl_name = "cust_look"
        open cur_cust_look using p_rcashe.cust_code
        fetch cur_cust_look into p_rcashe.bus_name,
          p_rcashe.on_acct_amt
        let stat = sqlca.sqlcode
        close cur_cust_look
      when tbl_name = "acct_look"
        open cur_acct_look using p_rcashe.cash_acct
        fetch cur_acct_look into scratch
        let stat = sqlca.sqlcode
        close cur_acct_look
      when tbl_name = "dept_look"
        open cur_dept_look using p_rcashe.cash_department
        fetch cur_dept_look into scratch
        let stat = sqlca.sqlcode
        close cur_dept_look
    end case

    # No mustfind is this_data is empty
    if length(this_data) = 0 then let mustfind = false end if

    # Send notfound message to user (if requested)
    let sqlca.sqlcode = stat
    if mustfind and stat = notfound
      then call scr_error("lookup=notfound",tbl_name)
    end if
    let sqlca.sqlcode = 0

    # Return false if lookup failed and empty into fields
    if stat = notfound
    then
        case
          when tbl_name = "acct_look" or tbl_name = "dept_look"
            initialize scratch to null
          when tbl_name = "cust_look"
            initialize p_rcashe.bus_name to null
            initialize p_rcashe.on_acct_amt to null
        end case
        return false
    else
        return true
    end if
end function
# llh_lookup();

input 2
define
    inv_doc_no like strcashd.inv_doc_no,
    dist_acct like strcashd.dist_acct,
    dist_department like strcashd.dist_department;

on_screen_record_prep
    select * into m_ropend.* from stropend
        where stropend.doc_no = m_rcashd.inv_doc_no
    if sqlca.sqlcode = notfound
    then
        let m_ropend.disc_bal = 0
        let m_ropend.balance = 0
    end if
    let p_rcashd[n].inv_no = m_ropend.inv_no
    let q_rcashd[n].inv_doc_no = m_ropend.doc_no
    let p_rcashd[n].due_date = m_ropend.due_date
    let p_rcashd[n].disc_date = m_ropend.disc_date
    let p_rcashd[n].disc_bal = m_ropend.disc_bal - m_rcashd.disc_amt
    if m_rcashd.dist_deb_cred = "DB"
    then
        let p_rcashd[n].balance = m_ropend.balance + m_rcashd.dist_amt
    else
        let p_rcashd[n].balance = m_ropend.balance - m_rcashd.dist_amt
    end if
    let m_rcashd.dist_acct = m_ropend.ar_acct_no
    let m_rcashd.dist_department = m_ropend.ar_department
    let p_rcashd[n].pay_method = null
    if m_rcashd.dist_amt is null
      then let m_rcashd.dist_amt = 0 end if
    if m_rcashd.disc_amt is null
      then let m_rcashd.disc_amt = 0 end if
    let q_rcashd[n].dist_acct = m_rcashd.dist_acct
    let q_rcashd[n].dist_department = m_rcashd.dist_department
    let p_rcashd[n].paid = m_rcashd.dist_amt
    if m_rcashd.dist_deb_cred = "DB"
    then
        let p_rcashd[n].paid = m_rcashd.dist_amt * -1
    end if
    let p_rcashd[n].disc_amt = m_rcashd.disc_amt
    if m_rcashd.disc_deb_cred = "CR"
    then
        let p_rcashd[n].disc_amt = m_rcashd.disc_amt * -1
    end if
    let p_rcashe.disc_tot = p_rcashe.disc_tot + p_rcashd[n].disc_amt
    let p_rcashe.paid_tot = p_rcashe.paid_tot + p_rcashd[n].disc_amt;
on_disk_record_prep
    let m_rcashd.inv_no = p_rcashd[n].inv_no
    let m_rcashd.due_date = p_rcashd[n].due_date
    let m_rcashd.disc_amt = p_rcashd[n].disc_amt
    let m_rcashd.disc_acct = m_rcntrc.cr_disc_acct_no
    let m_rcashd.disc_department = m_rcashd.dist_department
    let m_rcashd.disc_deb_cred = "DB"
    if p_rcashd[n].paid is not null
    then   
        let m_rcashd.dist_deb_cred = "CR"
        let m_rcashd.dist_amt = p_rcashd[n].paid
        if p_rcashd[n].paid < 0
        then
            let m_rcashd.dist_amt = p_rcashd[n].paid * -1
            let m_rcashd.dist_deb_cred = "DB"
        end if
    end if
    if m_rcashd.disc_amt < 0
    then
        let m_rcashd.disc_amt = m_rcashd.disc_amt * -1
        let m_rcashd.disc_deb_cred = "CR"
    end if;

    before_input
        # no detail lines, assume the tab key is pressed
        if rec1_cnt = 0 
        then 
          call fg_err(1)  # no outstanding open items for this customer
          return -1 
        end if ; 

    before_insert
        let nxt_fld = "goto top"
        return;

    before_delete
        let p_rcashe.disc_tot = p_rcashe.disc_tot - p_rcashd[p_cur].disc_amt
        let p_rcashe.paid_tot = p_rcashe.paid_tot - p_rcashd[p_cur].paid
        let p_rcashe.bal_remaining = p_rcashe.bal_remaining +
            p_rcashd[p_cur].paid - p_rcashd[p_cur].disc_amt
        display by name p_rcashe.disc_tot,
                        p_rcashe.paid_tot, p_rcashe.bal_remaining;
    after_change_in pay_method
        if p_rcashd[p_cur].pay_method matches "[iI]"
        then
            let scratch = 
              " stropend.doc_no = \"", q_rcashd[p_cur].inv_doc_no, "\""
            if zoom("arinvcz","(see scratch)") then end if
            let p_rcashd[p_cur].pay_method = null
            let nxt_fld = "pay_method"
            return
        end if
        if p_rcashd[p_cur].pay_method matches "[cC]"
        then
            call cust_detail(m_rcashe.cust_code)
            let p_rcashd[p_cur].pay_method = null
            let nxt_fld = "pay_method"
        end if 
        if p_rcashd[p_cur].pay_method < "1" or
           p_rcashd[p_cur].pay_method > "4"
        then
            call fg_err(10) # Payment method must be between 1 and 4
            let p_rcashd[p_cur].pay_method = null
            let nxt_fld = "pay_method"
        end if
        call pay_ar_line(p_cur,p_rcashd[p_cur].pay_method)
        let p_rcashd[p_cur].pay_method = null
        display p_rcashd[p_cur].* to s_rcashd[s_cur].*
        display by name p_rcashe.paid_tot, p_rcashe.disc_tot, 
                p_rcashe.bal_remaining;
    after_input
        if tab_pressed = false
          then call cust_unlock() end if;
    on_event cancel
        call cust_unlock()
        if no_cancel()
        then
          let int_flag = false
          let nxt_fld = null
        else
          let int_flag = true
          let nxt_fld = "exit input"
        end if;
    at_eof
######################################################################
function lld_read()
######################################################################
# This function reads in the array elements from disk.
# It first reads the data into the m_* records, then calls
# p_prep for each array element.
#
    define
        row_id integer  # Rowid of the fetched element

    # Prepare the cursor upon first invocation
    if select_prep is null
    then
        let select_prep = "Y"
        let scratch = "select rowid, * from strcashd ",
          "where strcashd.doc_no = ? order by due_date, inv_doc_no"
        prepare read_specs from scratch
        declare d_cursor cursor for read_specs
    end if

    # Read in the detail lines
    let p_cur = 0
    open d_cursor using m_rcashe.doc_no
    foreach d_cursor into row_id, m_rcashd.*
        let p_cur = p_cur + 1
        if p_cur > rec1_max
        then
            let sqlca.sqlcode = -1
            return
        end if
        call lld_p_prep(p_cur)
        let q_rcashd[p_cur].row_id = row_id
    end foreach
    close d_cursor
    let rec1_cnt = p_cur
    call set_count(rec1_cnt)
end function
# lld_read()

######################################################################
function lld_add()
######################################################################
# This function inserts data into the detail table.
#
    # Declare an insert cursor for maximum efficiency
    if insert_prep is null
    then
        let insert_prep = "Y"
        declare d_insert cursor for
          insert into strcashd values(m_rcashd.*)
    end if

    # Insert all array elements
    open d_insert
    for p_cur = 1 to rec1_cnt
        call lld_m_prep(p_cur)
        if m_rcashd.dist_amt != 0 or
           m_rcashd.disc_amt != 0
        then
            put d_insert
        end if
    end for
    close d_insert

end function
# lld_add();
