########################################################################
# Copyright (C) 1988,1989,1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_delete.4gs/prevmnth.4gl  1.4  Delta: 2/2/91
########################################################################

globals "globals.4gl"

#######################################################################
function get_arc_date()
#######################################################################
#  this function sets the ct.* record values
#
    define
        n       smallint,   # working number
        p_yes_no char(1),   # are you sure?
        p_arc_date date,    # archive date
        arg_flag char(1),   # archive type d=date,m=month,p=prompt user
        arc_month smallint

    let arg_flag = "P"

    for n = 1 to num_args()
        if arg_val(n) = "-date"
        then
            let p_arc_date = arg_val(n+1)
            let arg_flag = "D"
            exit for
        end if
        if arg_val(n) = "-month"
        then
            let arc_month = arg_val(n+1)
            let arg_flag = "M"
            exit for
        end if
    end for
    if arg_flag = "P"
    then
        call sel_wind()
        call menu_line()
        while arg_flag != "M" and arg_flag != "D"
            prompt " Archive by (M)onth or by (D)ate? " 
              for char arg_flag
            if arg_flag is null then let arg_flag = "p" end if
            if int_flag != 0
            then
                exit program(1)
            end if 
            let arg_flag = upshift(arg_flag)
            if arg_flag != "M" and arg_flag !="D"
            then
                call fg_err(1) #Enter a "M" for Month  or a "D" for Date
            end if
        end while
        if upshift(arg_flag) = "M" 
        then
            let arg_flag = "P"
            while arg_flag != "M"
                whenever error continue
                prompt 
                " Enter the Number of Months before today to archive: " 
                    for arc_month
                if sqlca.sqlcode = 0
                then
                    let arg_flag = "M"
                else
                    let sqlca.sqlcode = 0
                    call fg_err(2) #Enter a valid number
                end if
                whenever error call error_handler
                if int_flag != 0
                then
                    exit program(1)
                end if 
            end while
        else 
            let arg_flag = "P"
            while arg_flag != "D"
                whenever error continue
                prompt " Enter the Archive Date: " 
                    for p_arc_date
                if sqlca.sqlcode = 0
                then
                    let arg_flag = "D"
                else
                    let sqlca.sqlcode = 0
                    call fg_err(3) #Enter a valid date
                end if
                whenever error call error_handler
                if int_flag != 0
                then
                    exit program(1)
                end if 
             end while
        end if
    end if
    if arg_flag = "M"
    then
        call prev_month(arc_month) returning p_arc_date
    end if 


    if p_arc_date >= today - 730
    then
        prompt " The archive date is within the past two years.  Continue? "
          for char p_yes_no
        if upshift(p_yes_no) != "Y" then exit program(1) end if
    end if
    close window selwin

    return p_arc_date
end function
# get_date()

#############################################################
function prev_month(no_month)
#############################################################
#
# this function returns a date that is x number of months 
# previous to today's date (valid within 10 years or so)
#

    define
        no_month smallint,
        a_date date,
        tmp_month smallint,
        tmp_day smallint,
        tmp_year smallint

    # Trap fatal errors
    whenever error call error_handler

    let tmp_day = day(today)
    let a_date = mdy(month(today),1,year(today))
    let a_date = a_date - (no_month * 28)
    if no_month > 60 then let a_date = a_date - 25 end if
    let tmp_month = month(a_date)
    let tmp_year = year(a_date)

    return mdy(tmp_month,tmp_day,tmp_year)

end function
# prev_month
