########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_fichgr.4gs/lowlevel.4gl  1.7  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
        return
    end if

    if group_key = "cust_code" then
        # insert "before group of cust_code" code here
        let rpt.past_bal = 0
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    if rpt.date_type = "D"
    then
        let rpt.sel_date = curs.due_date
        let rpt.fc_type = "Due Date"
    else
        let rpt.sel_date = curs.inv_date
        let rpt.fc_type = "Invoice Date"
    end if
    let rpt.cust_code = curs.cust_code
    let rpt.bus_name = curs.bus_name
    let rpt.doc_no = curs.doc_no
    let rpt.inv_no = curs.inv_no
    let rpt.balance = curs.balance
    let rpt.past_bal = rpt.past_bal + rpt.balance
    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20),   # group identification
        scratch char(15)

    if group_key = "cust_code" then
        # insert "after group of cust_code" code here
        let scratch = rpt.past_bal * rpt.fc_pct / 100
        let rpt.fc_bal = scratch
        if rpt.fc_bal < rpt.min_chrg
        then
            let rpt.fc_bal = rpt.min_chrg
        end if
        call create_inv()
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()

#######################################################################
function create_inv()
#######################################################################
#
#
   define
       newdoc_no like strinvce.doc_no,
       fc_bal like strinvce.ar_amount,
       cr_db       char(2),
       fc_desc     char(30)

   let newdoc_no = al_uniq()
   let fc_desc = "FINANCE CHARGE" 

   insert into strinvce 
              (doc_no, department, file_type,
               inv_desc, inv_date, cust_code, ship_to_code,
               posted, due_date, ar_acct_no,
               ar_department, ar_amount, ar_debit_credit,
               disc_date, disc_amount)
       values (newdoc_no, curs.ar_department, "F",
               fc_desc, rpt.fc_date, rpt.cust_code, "SHIPTO",
               "N", rpt.fc_date, curs.ar_acct_no,
               curs.ar_department, rpt.fc_bal, "DB",
               rpt.fc_date, 0)

   call al_chrtn(m_rcntrc.ar_fc_acct_no) returning fc_desc, cr_db

   # in case fc account does not increase with a credit
   if cr_db != "CR"  
   then
     let fc_bal = rpt.fc_bal * -1
   else
     let fc_bal = rpt.fc_bal
   end if

   insert into strinvcd (doc_no, line_no, acct_no, department,
                         amount, debit_credit, description)
        values (newdoc_no, 1, m_rcntrc.ar_fc_acct_no, curs.ar_department,
                fc_bal, "CR", fc_desc)

end function
# create_inv
