########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_fichgr.4gs/midlevel.4gl  1.8  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote char(1)

    # Trap fatal errors
    whenever error call error_handler

    let quote = "\""

    let ct.sel_join =
        "stropend.cust_code = strcustr.cust_code and ",
        "stropend.balance > 0 and strcustr.fin_chg = ", quote, "Y", quote
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
#   let ct.sel_filter = "1=1"
    define
        a_flag smallint,
        scratch char(70),
        quote char(1)

    let quote = "\""

    call sel_wind()
    open form finance from "screen1"
    display form finance
    display "ENTER SELECTION CRITERIA" at 2,2 attribute(white)
    display "Press [Esc] to Select" at 1,47 attribute(white)
    display "Press [DEL] to Cancel" at 2,47 attribute(white)
    let rpt.fc_date = null
    let rpt.date_type = null
    let rpt.days_past  = null
    let rpt.min_chrg = 0.00
    let rpt.fc_pct = null
    let rpt.fc_on_fc = null
    let a_flag = true

    while a_flag
        input rpt.fc_date, rpt.date_type, rpt.days_past,
              rpt.fc_pct, rpt.min_chrg, rpt.fc_on_fc without defaults
                from s_finance.*

        after field fc_date
            if rpt.fc_date is null
            then
                let rpt.fc_date = today
                display by name rpt.fc_date
            end if
        after field date_type
            if rpt.date_type != "D" and rpt.date_type != "I"
            then
                call fg_err(1) #Finance on type must be a "D" or "I"
                let rpt.date_type = null
                display by name rpt.date_type
                next field date_type
            end if
        after field min_chrg
            if rpt.min_chrg is null
            then
                let rpt.min_chrg = 0.00
                display by name rpt.min_chrg
            end if
        after field fc_on_fc
            if rpt.fc_on_fc != "Y" and rpt.fc_on_fc != "N"
            then
                call fg_err(2) #Finance Charge on Finance Charge "Y" or "N"
                let rpt.fc_on_fc = null
                display by name rpt.fc_on_fc
                next field fc_on_fc
            end if
        end input
        if int_flag != 0
        then
            exit program(1)
        end if
        if mustfill(rpt.fc_date,"F.C. Date") or
           mustfill(rpt.date_type,"Charge On") or
           mustfill(rpt.days_past,"Days Past Due") or
           mustfill(rpt.fc_pct,"Finance Charge Percent") or
           mustfill(rpt.fc_on_fc,"F.C. on F.C.")
        then
            let a_flag = true
        else
            let a_flag = false
        end if
    end while
    close form finance
    close window selwin

    if rpt.date_type = "D"
    then
        let rpt.fc_type = "due_date"
    else
        let rpt.fc_type = "inv_date"
     end if
    if rpt.fc_on_fc = "N"
    then
        let scratch = " and (stropend.item_type != ",quote,"FC",quote,
                      " or stropend.item_type is null)"
    else
        let scratch = null
    end if
    let ct.sel_filter = "stropend.", rpt.fc_type clipped, " <= ",
          quote, rpt.fc_date - rpt.days_past, quote, scratch clipped

    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "stropend.cust_code, stropend.", rpt.fc_type clipped
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stropend, strcustr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "stropend.cust_code, ",
            "strcustr.bus_name, ",
            "stropend.doc_no, ",
            "stropend.inv_no, ",
            "stropend.balance, ",
            "stropend.inv_date, ",
            "stropend.due_date, ",
            "stropend.ar_acct_no, ",
            "stropend.ar_department ",
        "from stropend, strcustr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.cust_code = curs_next.cust_code
    let curs.bus_name = curs_next.bus_name
    let curs.doc_no = curs_next.doc_no
    let curs.inv_no = curs_next.inv_no
    let curs.balance = curs_next.balance
    let curs.inv_date = curs_next.inv_date
    let curs.due_date = curs_next.due_date
    let curs.ar_acct_no = curs_next.ar_acct_no
    let curs.ar_department = curs_next.ar_department
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.cust_code = curs_next.cust_code
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("cust_code")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.cust_code = curs_next.cust_code
    then else
        call after_group("cust_code")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Finance Charge Invoices"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "1"
    let ct.allow_int = "N"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

#######################################################################
function mustfill(fld,mssg)
# returning true/false based upon fld=null/not null respectively
#######################################################################
#
    define
        fld     char(10),       # field passed
        mssg    char(50)        # message for error statement
    if fld is null
    then
        error " ",mssg clipped," field must be filled. "
        sleep 2
        return true
    end if
    return false    # field is not null
end function
# mustfill()
