########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_fichgr.4gs/report.4gl  1.8  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            co_name like stxcntrc.co_name,
            fc_date date,
            fc_type char(12),
            days_past smallint,
            fc_pct smallfloat,
            min_chrg like stropend.balance,
            fc_on_fc char(1),
            cust_code like stropend.cust_code,
            bus_name like strcustr.bus_name,
            doc_no like stropend.doc_no,
            inv_no like stropend.inv_no,
            sel_date date,
            balance like stropend.balance,
            past_bal like stropend.balance,
            fc_bal like stropend.balance,
            date_type char(1)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.cust_code

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Finance Charge Invoices"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   5, "Finance Charge Date: ",
                column  26, rpt.fc_date
            print
                column  15, "Charge on: ",
                column  26, rpt.fc_type
            print
                column   1, "Number of Days past Due: ",
                column  26, rpt.days_past
            print
                column   2, "Finance Charge Percent: ",
                column  26, rpt.fc_pct , "%"
            print
                column  11, "Take FC on FC: ",
                column  26, rpt.fc_on_fc
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Finance Charge Invoices"
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.cust_code
            need 4 lines
            print
                column   3, rpt.cust_code clipped,
                            " ", "-" clipped,
                            " ", rpt.bus_name
            print
            print
                column   3, "Doc#",
                column  19, "Invoice#",
                column  40, rpt.fc_type,
                column  58, "Invoice Balance"
            print
                column   3, "------",
                column  19, "----------",
                column  40, "------------",
                column  58, "---------------"

        on every row
            print
                column   3, rpt.doc_no using "<<<<<<",
                column  19, rpt.inv_no,
                column  40, rpt.sel_date,
                column  60, rpt.balance using "----------.&&"

        after group of rpt.cust_code
            need 5 lines
            print
                column  58, "==============="
            print
                column  35, "Total Amount Past Due:",
                column  60, rpt.past_bal using "----------.&&"
            print
                column  58, "---------------"
            print
                column  36, "Total Finance Charge:",
                column  60, rpt.fc_bal using "----------.&&"
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        on last row
            print
                column  58, "---------------"
            print
                column  28, "Total of All Finance Charges:",
                column  60, sum(rpt.fc_bal) using "----------.&&"

end report
# report1()

