########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_recurr.4gs/lowlevel.4gl  1.9  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20),   # group identification
        db_cr char(2)

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
          let rpt.db_amount = 0.00
          let rpt.cr_amount = 0.00
        return
    end if

    if group_key = "recurr_ref" then
        # insert "before group of recurr_ref" code here
        let rpt.file_type = curs.file_type
        let rpt.ref_no = curs.ref_no
        let rpt.inv_no = curs.inv_no
        let rpt.inv_desc = curs.inv_desc
        let rpt.due_date = curs.due_date
        let rpt.disc_date = curs.disc_date
        let rpt.po_no = curs.po_no
        let rpt.po_date = curs.po_date
        let rpt.recurr_ref = curs.recurr_ref
        let rpt.inv_date = curs.inv_date
        let rpt.cust_code = curs.cust_code
        let rpt.bus_name = ar_custn(rpt.cust_code)
        let rpt.misc_acct_no = curs.misc_acct_no
        let rpt.misc_department = curs.misc_department
        call al_chrtn(rpt.misc_acct_no) returning rpt.misc_desc, db_cr
        let rpt.misc_amount = curs.misc_amount
        let rpt.misc_debit_credit = curs.misc_debit_credit
        let rpt.tax_acct_no = curs.tax_acct_no
        let rpt.tax_department = curs.tax_department
        call al_chrtn(rpt.tax_acct_no) returning rpt.tax_desc, db_cr
        let rpt.tax_amount = curs.tax_amount
        let rpt.tax_debit_credit = curs.tax_debit_credit
        let rpt.frght_acct_no = curs.frght_acct_no
        let rpt.frght_department = curs.frght_department
        call al_chrtn(rpt.frght_acct_no) returning rpt.frght_desc, db_cr
        let rpt.frght_amount = curs.frght_amount
        let rpt.frght_debit_credit = curs.frght_debit_credit
        let rpt.ar_acct_no = curs.ar_acct_no
        let rpt.ar_department = curs.ar_department
        call al_chrtn(rpt.ar_acct_no) returning rpt.ar_desc, db_cr
        let rpt.ar_amount = curs.ar_amount
        let rpt.ar_debit_credit = curs.ar_debit_credit
        call create_header()
        return
    end if

    if group_key = "line_no" then
        # insert "before group of line_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#

    let rpt.line_no = curs.line_no

    if rpt.line_no < 0 # do not print frght,misc,tax,and total line
    then
        let rpt.acct_no = null
        let rpt.department = null
        let rpt.description = null
        let rpt.amount = null
        let rpt.debit_credit = null
    else
        let rpt.acct_no = curs.acct_no
        let rpt.department = curs.department
        let rpt.description = curs.description
        let rpt.amount = curs.amount
        let rpt.debit_credit = curs.debit_credit
    end if

    if rpt.amount is not null
    then
       if rpt.debit_credit = "DB"
       then
          let rpt.db_amount = rpt.db_amount + rpt.amount
       else
          let rpt.cr_amount = rpt.cr_amount + rpt.amount
       end if
    end if

    call create_detail()

    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "recurr_ref" then
        # insert "after group of recurr_ref" code here

          if rpt.misc_amount is not null
          then
             if rpt.misc_debit_credit = "DB"
             then
                let rpt.db_amount = rpt.db_amount + rpt.misc_amount
             else
                let rpt.cr_amount = rpt.cr_amount + rpt.misc_amount
             end if
          end if

          if rpt.tax_amount is not null
          then
             if rpt.tax_debit_credit = "DB"
             then
                let rpt.db_amount = rpt.db_amount + rpt.tax_amount
             else
                let rpt.cr_amount = rpt.cr_amount + rpt.tax_amount
             end if
          end if

          if rpt.frght_amount is not null
          then
             if rpt.frght_debit_credit = "DB"
             then
                let rpt.db_amount = rpt.db_amount + rpt.frght_amount
             else
                let rpt.cr_amount = rpt.cr_amount + rpt.frght_amount
             end if
          end if

          if rpt.ar_amount is not null
          then
             if rpt.ar_debit_credit = "DB"
             then
                let rpt.db_amount = rpt.db_amount + rpt.ar_amount
             else
                let rpt.cr_amount = rpt.cr_amount + rpt.ar_amount
             end if
          end if

        return
    end if

    if group_key = "line_no" then
        # insert "after group of line_no" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()

#######################################################################
function create_header()
#######################################################################
# creates invoice header table information
#
   define
       duedays integer,
       discdays integer

   select * into m_rinvce.* from strinvce where strinvce.doc_no = curs.doc_no

   let m_rinvce.doc_no = al_uniq()
   let m_rinvce.posted = "N"
   let m_rinvce.ok_to_post = "N"
   let duedays = m_rinvce.due_date - m_rinvce.inv_date
   let discdays = m_rinvce.disc_date - m_rinvce.inv_date
   let m_rinvce.inv_date = today
   let m_rinvce.due_date = m_rinvce.inv_date + duedays
   let m_rinvce.disc_date = m_rinvce.inv_date + discdays

   delete from strinvce where strinvce.doc_no = curs.doc_no
   insert into strinvce values(m_rinvce.*)

end function
# create_header

#######################################################################
function create_detail()
#######################################################################
#
   define
       m_rinvcd record like strinvcd.*

   select * into m_rinvcd.* from strinvcd
       where strinvcd.doc_no = curs.doc_no and
             strinvcd.line_no = rpt.line_no

   let m_rinvcd.doc_no = m_rinvce.doc_no
   update strinvcd set * =  m_rinvcd.*
       where strinvcd.doc_no = curs.doc_no and
             strinvcd.line_no = rpt.line_no

end function
# create_detail
