########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/p_recurr.4gs/report.4gl  1.6  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            file_type like strinvce.file_type,
            ref_no like strinvce.ref_no,
            debit_credit like strinvcd.debit_credit,
            line_no like strinvcd.line_no,
            due_date like strinvce.due_date,
            disc_date like strinvce.disc_date,
            po_no like strinvce.po_no,
            po_date like strinvce.po_date,
            co_name like stxcntrc.co_name,
            recurr_ref like strinvce.recurr_ref,
            inv_date like strinvce.inv_date,
            cust_code like strinvce.cust_code,
            bus_name like strcustr.bus_name,
            inv_no like strinvce.inv_no,
            inv_desc like strinvce.inv_desc,
            acct_no like strinvcd.acct_no,
            department like strinvcd.department,
            description like strinvcd.description,
            amount like strinvcd.amount,
            misc_acct_no like strinvce.misc_acct_no,
            misc_department like strinvce.misc_department,
            misc_desc char(30),
            misc_amount like strinvce.misc_amount,
            misc_debit_credit like strinvce.misc_debit_credit,
            tax_acct_no like strinvce.tax_acct_no,
            tax_department like strinvce.tax_department,
            tax_desc char(30),
            tax_amount like strinvce.tax_amount,
            tax_debit_credit like strinvce.tax_debit_credit,
            frght_acct_no like strinvce.frght_acct_no,
            frght_department like strinvce.frght_department,
            frght_desc char(30),
            frght_amount like strinvce.frght_amount,
            frght_debit_credit like strinvce.frght_debit_credit,
            ar_acct_no like strinvce.ar_acct_no,
            ar_department like strinvce.ar_department,
            ar_desc char(30),
            ar_amount like strinvce.ar_amount,
            ar_debit_credit like strinvce.ar_debit_credit,
            db_amount decimal(11,2),
            cr_amount decimal(11,2)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.recurr_ref, rpt.line_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Recurring Invoice"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Recurring Invoice";
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.recurr_ref
            if
                rpt.acct_no is not null
             or rpt.department is not null
             or rpt.description is not null
             or rpt.amount is not null
             or rpt.debit_credit is not null
            then
                let dynamic = true
                need 5 lines
            else
                let dynamic = false
                need 3 lines
            end if

            print
                column   4, "Document Number: ",
                            " ", rpt.recurr_ref using "<<<<<<<<",
                column  35, "Date: ",
                column  41, rpt.inv_date using "mm/dd/yy"
            print
                column  11, "Customer: " clipped,
                            " ", rpt.cust_code clipped,
                            " ", "-" clipped,
                            " ", rpt.bus_name
            print
                column   8, "Description: ",
                column  21, rpt.inv_desc
            if dynamic
            then
                print
            end if
            if dynamic
            then
                print
                    column   7, "Account",
                    column  59, "Amount"
            end if

        on every row
            if
                rpt.acct_no is not null
             or rpt.department is not null
             or rpt.description is not null
             or rpt.amount is not null
             or rpt.debit_credit is not null
            then
                print
                    column   7, rpt.acct_no using "######",
                    column  14, "- ",
                    column  16, rpt.department,
                    column  22, rpt.description,
                    column  52, rpt.amount using "(((,(((,(((.&&)",
                    column  67, rpt.debit_credit
            end if

        after group of rpt.recurr_ref
            need 5 lines
            if
                rpt.misc_acct_no is not null
             or rpt.misc_department is not null
             or rpt.misc_desc is not null
             or rpt.misc_amount is not null
             or rpt.misc_debit_credit is not null
            then
                print
                    column   7, rpt.misc_acct_no using "######",
                    column  14, "- ",
                    column  16, rpt.misc_department,
                    column  22, rpt.misc_desc,
                    column  50, rpt.misc_amount using "(((,(((,(((.&&)",
                    column  67, rpt.misc_debit_credit
            end if
            if
                rpt.tax_acct_no is not null
             or rpt.tax_department is not null
             or rpt.tax_desc is not null
             or rpt.tax_amount is not null
             or rpt.tax_debit_credit is not null
            then
                print
                    column   7, rpt.tax_acct_no using "######",
                    column  14, "- ",
                    column  16, rpt.tax_department,
                    column  22, rpt.tax_desc,
                    column  50, rpt.tax_amount using "(((,(((,(((.&&)",
                    column  67, rpt.tax_debit_credit
            end if
            if
                rpt.frght_acct_no is not null
             or rpt.frght_department is not null
             or rpt.frght_desc is not null
             or rpt.frght_amount is not null
             or rpt.frght_debit_credit is not null
            then
                print
                    column   7, rpt.frght_acct_no using "######",
                    column  14, "- ",
                    column  16, rpt.frght_department,
                    column  22, rpt.frght_desc,
                    column  50, rpt.frght_amount using "(((,(((,(((.&&)",
                    column  67, rpt.frght_debit_credit
            end if
            if
                rpt.ar_acct_no is not null
             or rpt.ar_department is not null
             or rpt.ar_desc is not null
             or rpt.ar_amount is not null
             or rpt.ar_debit_credit is not null
            then
                print
                    column   7, rpt.ar_acct_no using "######",
                    column  14, "- ",
                    column  16, rpt.ar_department,
                    column  22, rpt.ar_desc,
                    column  50, rpt.ar_amount using "(((,(((,(((.&&)",
                    column  67, rpt.ar_debit_credit
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        on last row
            need 4 lines
            print
                column   1, "========================================",
                column  41, "========================================"
            print
            print
                column  18, "Total Debits",
                column  46, "Total Credits"
            print
                column  13, rpt.db_amount using "((,(((,(((,(((.&&)",
                column  42, rpt.cr_amount using "((,(((,(((,(((.&&)"

end report
# report1()
